commit 6b2f6d934757cb502817665692b1005b84331037
Author: freddy77 <freddy77>
Date:   Tue Jan 29 14:30:48 2008 +0000

    reuse code

diff --git a/ChangeLog b/ChangeLog
index 09c3d0d..800bfc2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,27 @@
+Tue Jan 29 15:28:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/array_out.c src/odbc/unittests/common.c:
+	* src/odbc/unittests/common.h src/odbc/unittests/compute.c:
+	* src/odbc/unittests/connect2.c src/odbc/unittests/const_params.c:
+	* src/odbc/unittests/copydesc.c src/odbc/unittests/cursor1.c:
+	* src/odbc/unittests/cursor2.c src/odbc/unittests/cursor3.c:
+	* src/odbc/unittests/cursor4.c src/odbc/unittests/cursor5.c:
+	* src/odbc/unittests/data.c src/odbc/unittests/date.c:
+	* src/odbc/unittests/error.c src/odbc/unittests/funccall.c:
+	* src/odbc/unittests/genparams.c src/odbc/unittests/getdata.c:
+	* src/odbc/unittests/hidden.c src/odbc/unittests/lang_error.c:
+	* src/odbc/unittests/moreandcount.c src/odbc/unittests/norowset.c:
+	* src/odbc/unittests/params.c src/odbc/unittests/prepare_results.c:
+	* src/odbc/unittests/print.c src/odbc/unittests/putdata.c:
+	* src/odbc/unittests/raiserror.c src/odbc/unittests/rebindpar.c:
+	* src/odbc/unittests/scroll.c src/odbc/unittests/t0001.c:
+	* src/odbc/unittests/t0002.c src/odbc/unittests/t0003.c:
+	* src/odbc/unittests/t0004.c src/odbc/unittests/tables.c:
+	* src/odbc/unittests/test64.c src/odbc/unittests/timeout.c:
+	* src/odbc/unittests/timeout2.c src/odbc/unittests/timeout4.c:
+	* src/odbc/unittests/transaction.c src/odbc/unittests/typeinfo.c:
+	* src/odbc/unittests/warning.c:
+	- reuse reuse reuse!
+
 Tue Jan 29 10:34:41 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c src/odbc/odbc.c src/odbc/odbc_util.c:
 	* src/odbc/unittests/getdata.c:
@@ -104,4 +128,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2479 2008/01/29 09:35:24 freddy77 Exp $
+$Id: ChangeLog,v 1.2480 2008/01/29 14:30:48 freddy77 Exp $
diff --git a/src/odbc/unittests/array_out.c b/src/odbc/unittests/array_out.c
index f99918d..1bbb852 100644
--- a/src/odbc/unittests/array_out.c
+++ b/src/odbc/unittests/array_out.c
@@ -3,7 +3,7 @@
 
 /* Test using array binding */
 
-static char software_version[] = "$Id: array_out.c,v 1.11 2007/11/26 20:03:17 freddy77 Exp $";
+static char software_version[] = "$Id: array_out.c,v 1.12 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static const char *test_query = NULL;
@@ -74,9 +74,7 @@ query_test(SQLRETURN expected, const char *expected_status)
 	SQLBindCol(Statement, 1, SQL_C_ULONG, &IDS(0), 0, &ID_LENS(0));
 	SQLBindCol(Statement, 2, SQL_C_CHAR, DESCS(0), desc_len, &DESC_LENS(0));
 
-	ret = SQLExecDirect(Statement, (SQLCHAR *) test_query, SQL_NTS);
-	if (ret != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Invalid result");
+	CHK(SQLExecDirect, (Statement, (SQLCHAR *) test_query, SQL_NTS));
 
 	ret = SQLFetch(Statement);
 	if (ret != expected)
diff --git a/src/odbc/unittests/common.c b/src/odbc/unittests/common.c
index 0fde53d..78f58fe 100644
--- a/src/odbc/unittests/common.c
+++ b/src/odbc/unittests/common.c
@@ -12,7 +12,7 @@
 #define TDS_SDIR_SEPARATOR "\\"
 #endif
 
-static char software_version[] = "$Id: common.c,v 1.42 2007/12/27 10:22:18 freddy77 Exp $";
+static char software_version[] = "$Id: common.c,v 1.43 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 HENV Environment;
@@ -251,9 +251,8 @@ Command(HSTMT stmt, const char *command)
 	printf("%s\n", command);
 	result = SQLExecDirect(stmt, (SQLCHAR *) command, SQL_NTS);
 	if (result != SQL_SUCCESS && result != SQL_NO_DATA) {
-		printf("Unable to execute statement\n");
+		fprintf(stderr, "Unable to execute statement\n");
 		CheckReturn();
-		exit(1);
 	}
 }
 
diff --git a/src/odbc/unittests/common.h b/src/odbc/unittests/common.h
index 175b164..b74e162 100644
--- a/src/odbc/unittests/common.h
+++ b/src/odbc/unittests/common.h
@@ -21,7 +21,7 @@
 #include <sql.h>
 #include <sqlext.h>
 
-static char rcsid_common_h[] = "$Id: common.h,v 1.21 2007/12/21 10:39:10 freddy77 Exp $";
+static char rcsid_common_h[] = "$Id: common.h,v 1.22 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_common_h_warn[] = { rcsid_common_h, no_unused_common_h_warn };
 
 #ifndef HAVE_SQLLEN
@@ -56,6 +56,12 @@ void ResetStatement(void);
 void CheckCursor(void);
 
 #define ODBC_REPORT_ERROR(msg) ReportError(msg, __LINE__, __FILE__)
+
+#define CHK(func,params) \
+	do { if (func params != SQL_SUCCESS) \
+		ODBC_REPORT_ERROR(#func); \
+	} while(0)
+
 int Connect(void);
 int Disconnect(void);
 void Command(HSTMT stmt, const char *command);
diff --git a/src/odbc/unittests/compute.c b/src/odbc/unittests/compute.c
index dfa0f58..11c0548 100644
--- a/src/odbc/unittests/compute.c
+++ b/src/odbc/unittests/compute.c
@@ -9,7 +9,7 @@
  * and declared in odbcss.h
  */
 
-static char software_version[] = "$Id: compute.c,v 1.9 2007/07/03 15:13:55 freddy77 Exp $";
+static char software_version[] = "$Id: compute.c,v 1.10 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static char col1[256], col2[256];
@@ -23,12 +23,9 @@ TestName(SQLSMALLINT index, const char *expected_name)
 	char name[128];
 	char buf[256];
 	SQLSMALLINT len, type;
-	SQLRETURN rc;
 
 #define NAME_TEST \
 	do { \
-		if (rc != SQL_SUCCESS) \
-			ODBC_REPORT_ERROR("SQLDescribeCol failed"); \
 		if (strcmp(name, expected_name) != 0) \
 		{ \
 			sprintf(buf, "line %d: wrong name in column %d expected '%s' got '%s'", \
@@ -38,14 +35,14 @@ TestName(SQLSMALLINT index, const char *expected_name)
 	} while(0)
 
 	/* retrieve with SQLDescribeCol */
-	rc = SQLDescribeCol(Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL);
+	CHK(SQLDescribeCol, (Statement, index, (SQLCHAR *) name, sizeof(name), &len, &type, NULL, NULL, NULL));
 	NAME_TEST;
 
 	/* retrieve with SQLColAttribute */
-	rc = SQLColAttribute(Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL);
+	CHK(SQLColAttribute, (Statement, index, SQL_DESC_NAME, name, sizeof(name), &len, NULL));
 	if (db_is_microsoft())
 		NAME_TEST;
-	rc = SQLColAttribute(Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL);
+	CHK(SQLColAttribute, (Statement, index, SQL_DESC_LABEL, name, sizeof(name), &len, NULL));
 	NAME_TEST;
 }
 
@@ -56,8 +53,7 @@ CheckFetch(const char *c1name, const char *c1, const char *c2)
 
 	TestName(1, c1name);
 
-	if (SQLFetch(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("error fetching");
+	CHK(SQLFetch, (Statement));
 
 	if (strlen(c1) != ind1 || strcmp(c1, col1) != 0) {
 		fprintf(stderr, "%s:%d: Column 1 error '%s' (%d) expected '%s' (%d)\n", __FILE__, main_line, col1, (int) ind1, c1,
@@ -107,8 +103,7 @@ main(int argc, char *argv[])
 	CheckFetch("c", "pluto", "3");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("No more data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	/* why I need to rebind ?? ms bug of feature ?? */
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
@@ -131,8 +126,7 @@ main(int argc, char *argv[])
 	CheckFetch("mao", "pippo", "34");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("No more data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
@@ -140,8 +134,7 @@ main(int argc, char *argv[])
 	CheckFetch("sum", "46", "##");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("No more data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
@@ -150,8 +143,7 @@ main(int argc, char *argv[])
 	CheckFetch("mao", "pluto", "3");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Still data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
@@ -159,8 +151,7 @@ main(int argc, char *argv[])
 	CheckFetch("sum", "6", "%");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Still data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
@@ -182,21 +173,17 @@ main(int argc, char *argv[])
 	CheckFetch("c", "pippo", "34");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("No more data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	/* here just skip results, before a row */
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Still data ??");
-
+	CHK(SQLMoreResults, (Statement));
 
 	SQLBindCol(Statement, 1, SQL_C_CHAR, col1, sizeof(col1), &ind1);
 	SQLBindCol(Statement, 2, SQL_C_CHAR, col2, sizeof(col2), &ind2);
 	CheckFetch("c", "pluto", "2");
 	if (SQLFetch(Statement) != SQL_NO_DATA)
 		ODBC_REPORT_ERROR("Still data ??");
-	if (SQLMoreResults(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("No more data ??");
+	CHK(SQLMoreResults, (Statement));
 
 	/* here just skip results, before done */
 	if (SQLMoreResults(Statement) != SQL_NO_DATA)
diff --git a/src/odbc/unittests/connect2.c b/src/odbc/unittests/connect2.c
index c7f01a9..0f00546 100644
--- a/src/odbc/unittests/connect2.c
+++ b/src/odbc/unittests/connect2.c
@@ -5,7 +5,7 @@
  * either SQLConnect and SQLDriverConnect
  */
 
-static char software_version[] = "$Id: connect2.c,v 1.4 2007/04/12 07:49:30 freddy77 Exp $";
+static char software_version[] = "$Id: connect2.c,v 1.5 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int failed = 0;
@@ -35,7 +35,6 @@ normal_connect(void)
 	if (!SQL_SUCCEEDED(res)) {
 		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
 		CheckReturn();
-		exit(1);
 	}
 }
 
@@ -50,7 +49,6 @@ driver_connect(const char *conn_str)
 	if (!SQL_SUCCEEDED(res)) {
 		fprintf(stderr, "Unable to open data source (ret=%d)\n", res);
 		CheckReturn();
-		exit(1);
 	}
 }
 
@@ -66,7 +64,6 @@ check_dbname(const char *dbname)
 	if (!SQL_SUCCEEDED(res)) {
 		fprintf(stderr, "Unable to get database name to %s\n", dbname);
 		CheckReturn();
-		exit(1);
 	}
 
 	if (strcmp(out, dbname) != 0) {
@@ -84,7 +81,6 @@ set_dbname(const char *dbname)
 	if (!SQL_SUCCEEDED(res)) {
 		fprintf(stderr, "Unable to set database name to %s\n", dbname);
 		CheckReturn();
-		exit(1);
 	}
 }
 
diff --git a/src/odbc/unittests/const_params.c b/src/odbc/unittests/const_params.c
index a9fabfe..a1482e1 100644
--- a/src/odbc/unittests/const_params.c
+++ b/src/odbc/unittests/const_params.c
@@ -2,7 +2,7 @@
 
 /* Test for {?=call store(?,123,'foo')} syntax and run */
 
-static char software_version[] = "$Id: const_params.c,v 1.13 2007/11/26 06:25:11 freddy77 Exp $";
+static char software_version[] = "$Id: const_params.c,v 1.14 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -26,22 +26,17 @@ main(int argc, char *argv[])
 		" return 24680\n"
 		"end");
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind input parameter");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind));
 
-	if (SQLBindParameter(Statement, 2, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1, 0, &ind2) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
+	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1, 0, &ind2));
 
 	/* TODO use {ts ...} for date */
-	if (SQLPrepare(Statement, (SQLCHAR *) "{call const_param(?, 13579, '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS) !=
-	    SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{call const_param(?, 13579, '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS));
 
 	input = 13579;
 	ind = sizeof(input);
 	out1 = output = 0xdeadbeef;
-	if (SQLExecute(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to execute statement");
+	CHK(SQLExecute, (Statement));
 
 	if (out1 != 7654321) {
 		fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
@@ -51,25 +46,17 @@ main(int argc, char *argv[])
 	/* just to reset some possible buffers */
 	Command(Statement, "DECLARE @i INT");
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
-
-	if (SQLBindParameter(Statement, 2, SQL_PARAM_INPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &input, 0, &ind2) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind input parameter");
-
-	if (SQLBindParameter(Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1, 0, &ind3) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
+	CHK(SQLBindParameter, (Statement, 2, SQL_PARAM_INPUT,  SQL_C_SLONG, SQL_INTEGER, 0, 0, &input,  0, &ind2));
+	CHK(SQLBindParameter, (Statement, 3, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &out1,   0, &ind3));
 
 	/* TODO use {ts ...} for date */
-	if (SQLPrepare(Statement, (SQLCHAR *) "{?=call const_param(?, , '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS) !=
-	    SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{?=call const_param(?, , '2004-10-15 12:09:08', 'foo', ?)}", SQL_NTS));
 
 	input = 13579;
 	ind2 = sizeof(input);
 	out1 = output = 0xdeadbeef;
-	if (SQLExecute(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to execute statement");
+	CHK(SQLExecute, (Statement));
 
 	if (out1 != 7654321) {
 		fprintf(stderr, "Invalid output %d (0x%x)\n", (int) out1, (int) out1);
@@ -81,8 +68,7 @@ main(int argc, char *argv[])
 		exit(1);
 	}
 
-	if (CommandWithResult(Statement, "drop proc const_param") != SQL_SUCCESS)
-		printf("Unable to execute statement\n");
+	Command(Statement, "IF OBJECT_ID('const_param') IS NOT NULL DROP PROC const_param");
 
 	Command(Statement, "create proc const_param @in1 float, @in2 varbinary(100) as\n"
 		"begin\n"
@@ -91,24 +77,19 @@ main(int argc, char *argv[])
 		" return 54321\n"
 		"end");
 
-	if (SQLBindParameter(Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to bind output parameter");
+	CHK(SQLBindParameter, (Statement, 1, SQL_PARAM_OUTPUT, SQL_C_SLONG, SQL_INTEGER, 0, 0, &output, 0, &ind));
 
-	if (SQLPrepare(Statement, (SQLCHAR *) "{?=call const_param(12.5, 0x0102030405060708)}", SQL_NTS) !=
-	    SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to prepare statement");
+	CHK(SQLPrepare, (Statement, (SQLCHAR *) "{?=call const_param(12.5, 0x0102030405060708)}", SQL_NTS));
 
 	output = 0xdeadbeef;
-	if (SQLExecute(Statement) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to execute statement");
+	CHK(SQLExecute, (Statement));
 
 	if (output != 54321) {
 		fprintf(stderr, "Invalid result %d (0x%x) expected 54321\n", (int) output, (int) output);
 		return 1;
 	}
 
-	if (CommandWithResult(Statement, "drop proc const_param") != SQL_SUCCESS)
-		printf("Unable to execute statement\n");
+	Command(Statement, "drop proc const_param");
 
 	Command(Statement, "create proc const_param @in varchar(20) as\n"
 		"begin\n"
@@ -119,7 +100,7 @@ main(int argc, char *argv[])
 	/* catch problem reported by Peter Deacon */
 	output = 0xdeadbeef;
 	Command(Statement, "{CALL const_param('value')}");
-	SQLBindCol(Statement, 1, SQL_C_SLONG, &output, 0, &ind);
+	CHK(SQLBindCol, (Statement, 1, SQL_C_SLONG, &output, 0, &ind));
 	SQLFetch(Statement);
 
 	if (output != 8421) {
@@ -129,8 +110,7 @@ main(int argc, char *argv[])
 
 	ResetStatement();
 
-	if (CommandWithResult(Statement, "drop proc const_param") != SQL_SUCCESS)
-		printf("Unable to execute statement\n");
+	Command(Statement, "drop proc const_param");
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/copydesc.c b/src/odbc/unittests/copydesc.c
index a92d2d9..75380bc 100644
--- a/src/odbc/unittests/copydesc.c
+++ b/src/odbc/unittests/copydesc.c
@@ -2,7 +2,7 @@
 
 /* Test SQLCopyDesc and SQLAllocHandle(SQL_HANDLE_DESC) */
 
-static char software_version[] = "$Id: copydesc.c,v 1.3 2007/04/12 07:49:30 freddy77 Exp $";
+static char software_version[] = "$Id: copydesc.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int
@@ -15,24 +15,20 @@ main(int argc, char *argv[])
 
 	Connect();
 
-	if (SQLGetStmtAttr(Statement, SQL_ATTR_APP_ROW_DESC, &ard, 0, NULL) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLGetStmtAttr");
+	CHK(SQLGetStmtAttr, (Statement, SQL_ATTR_APP_ROW_DESC, &ard, 0, NULL));
 
-	SQLBindCol(Statement, 1, SQL_C_SLONG, &id, sizeof(SQLINTEGER), &ind1);
-	SQLBindCol(Statement, 2, SQL_C_CHAR, name, sizeof(name), &ind2);
+	CHK(SQLBindCol, (Statement, 1, SQL_C_SLONG, &id, sizeof(SQLINTEGER), &ind1));
+	CHK(SQLBindCol, (Statement, 2, SQL_C_CHAR, name, sizeof(name), &ind2));
 
-	if (SQLAllocHandle(SQL_HANDLE_DESC, Connection, &ard2) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLAllocHandle");
+	CHK(SQLAllocHandle, (SQL_HANDLE_DESC, Connection, &ard2));
 
 	/*
 	 * this is an additional test to test additional allocation 
 	 * As of 0.64 for a bug in SQLAllocDesc we only allow to allocate one
 	 */
-	if (SQLAllocHandle(SQL_HANDLE_DESC, Connection, &ard3) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLAllocHandle");
+	CHK(SQLAllocHandle, (SQL_HANDLE_DESC, Connection, &ard3));
 
-	if (SQLCopyDesc(ard, ard2) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("SQLCopyDesc");
+	CHK(SQLCopyDesc, (ard, ard2));
 
 	Disconnect();
 
diff --git a/src/odbc/unittests/cursor1.c b/src/odbc/unittests/cursor1.c
index d10e777..28e4609 100644
--- a/src/odbc/unittests/cursor1.c
+++ b/src/odbc/unittests/cursor1.c
@@ -2,14 +2,9 @@
 
 /* Test cursors */
 
-static char software_version[] = "$Id: cursor1.c,v 1.12 2007/11/26 06:25:11 freddy77 Exp $";
+static char software_version[] = "$Id: cursor1.c,v 1.13 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHK(func,params) \
-	do { if (func params != SQL_SUCCESS) \
-		ODBC_REPORT_ERROR(#func); \
-	} while(0)
-
 #define CHK_INFO(func,params) \
 	do { if (!SQL_SUCCEEDED(func params)) \
 		ODBC_REPORT_ERROR(#func); \
@@ -145,11 +140,7 @@ Test0(int use_sql, const char *create_sql, const char *insert_sql, const char *s
 					exit(1);
 				}
 
-				retcode = SQLGetDiagRec(SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL);
-				if (retcode != SQL_SUCCESS) {
-					fprintf(stderr, "Error not expected at line %d\n", __LINE__);
-					exit(1);
-				}
+				CHK(SQLGetDiagRec, (SQL_HANDLE_STMT, Statement, 1, sqlstate, NULL, msg, sizeof(msg), NULL));
 				if (strstr((char *) msg, "Invalid column name 'c'") == NULL) {
 					fprintf(stderr, "Expected message not found at line %d\n", __LINE__);
 					exit(1);
diff --git a/src/odbc/unittests/cursor2.c b/src/odbc/unittests/cursor2.c
index d5fd48d..ac1d1db 100644
--- a/src/odbc/unittests/cursor2.c
+++ b/src/odbc/unittests/cursor2.c
@@ -2,13 +2,9 @@
 
 /* Test cursor do not give error for statement that do not return rows  */
 
-static char software_version[] = "$Id: cursor2.c,v 1.3 2007/04/20 13:27:14 freddy77 Exp $";
+static char software_version[] = "$Id: cursor2.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-#define CHK(func,params) \
-	if (func params != SQL_SUCCESS) \
-		ODBC_REPORT_ERROR(#func)
-
 int
 main(int argc, char *argv[])
 {
diff --git a/src/odbc/unittests/cursor3.c b/src/odbc/unittests/cursor3.c
index d44fe3c..6ef62c8 100644
--- a/src/odbc/unittests/cursor3.c
+++ b/src/odbc/unittests/cursor3.c
@@ -1,11 +1,9 @@
 /* Tests 2 active statements */
 #include "common.h"
 
-static char software_version[] = "$Id: cursor3.c,v 1.4 2008/01/10 15:29:03 freddy77 Exp $";
+static char software_version[] = "$Id: cursor3.c,v 1.5 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static SQLHDBC m_hdbc;
-
 #define CHECK_RCODE(t,h,m) \
    if ( rcode != SQL_NO_DATA \
      && rcode != SQL_SUCCESS \
@@ -43,7 +41,7 @@ exec_direct(int check, const char *stmt)
 	SQLRETURN rcode;
 	SQLHSTMT stmth = 0;
 
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hdbc, (SQLHANDLE *) & stmth);
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) Connection, (SQLHANDLE *) & stmth);
 	CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLAllocHandle");
 	rcode = SQLExecDirect(stmth, (SQLCHAR *) stmt, SQL_NTS);
 	if (check) {
@@ -67,8 +65,6 @@ main(int argc, char **argv)
 
 	CheckCursor();
 
-	m_hdbc = Connection;
-
 	exec_direct(1, "CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
 	exec_direct(1, "INSERT INTO #t1 VALUES (1, 'aaa')");
 	exec_direct(1, "INSERT INTO #t1 VALUES (2, 'bbbbb')");
@@ -76,12 +72,12 @@ main(int argc, char **argv)
 	exec_direct(1, "INSERT INTO #t1 VALUES (4, 'dd')");
 
 	m_hstmt1 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, m_hdbc, &m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_DBC, m_hdbc, "SQLAllocHandle 1");
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt1);
+	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle 1");
 
 	m_hstmt2 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, m_hdbc, &m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_DBC, m_hdbc, "SQLAllocHandle 2");
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt2);
+	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle 2");
 
 /*
 	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER) SQL_NONSCROLLABLE, SQL_IS_UINTEGER);
diff --git a/src/odbc/unittests/cursor4.c b/src/odbc/unittests/cursor4.c
index ef67014..363ebfd 100755
--- a/src/odbc/unittests/cursor4.c
+++ b/src/odbc/unittests/cursor4.c
@@ -5,11 +5,9 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: cursor4.c,v 1.4 2008/01/10 15:29:03 freddy77 Exp $";
+static char software_version[] = "$Id: cursor4.c,v 1.5 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
-static SQLHDBC m_hdbc;
-
 #define CHECK_RCODE(t,h,m) \
    if ( rcode != SQL_NO_DATA \
      && rcode != SQL_SUCCESS \
@@ -47,7 +45,7 @@ exec_direct(int check, const char *stmt)
 	SQLRETURN rcode;
 	SQLHSTMT stmth = 0;
 
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) m_hdbc, (SQLHANDLE *) & stmth);
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, (SQLHANDLE) Connection, (SQLHANDLE *) & stmth);
 	CHECK_RCODE(SQL_HANDLE_STMT, stmth, "SQLAllocHandle");
 	rcode = SQLExecDirect(stmth, (SQLCHAR *) stmt, SQL_NTS);
 	if (check) {
@@ -70,14 +68,12 @@ main(int argc, char **argv)
 
 	CheckCursor();
 
-	m_hdbc = Connection;
-
 	exec_direct(1, "CREATE TABLE #t1 ( k INT, c VARCHAR(20))");
 	exec_direct(1, "INSERT INTO #t1 VALUES (1, 'aaa')");
 
 	m_hstmt1 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, m_hdbc, &m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_DBC, m_hdbc, "SQLAllocHandle 1");
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt1);
+	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle 1");
 
 	rcode = SQLSetStmtAttr(m_hstmt1, SQL_ATTR_CONCURRENCY, (SQLPOINTER) SQL_CONCUR_LOCK, SQL_IS_UINTEGER);
 	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "Set attribute SQL_ATTR_CONCURRENCY");
diff --git a/src/odbc/unittests/cursor5.c b/src/odbc/unittests/cursor5.c
index 53f380b..d8c4540 100755
--- a/src/odbc/unittests/cursor5.c
+++ b/src/odbc/unittests/cursor5.c
@@ -1,6 +1,6 @@
 #include "common.h"
 
-static char software_version[] = "$Id: cursor5.c,v 1.3 2008/01/10 15:29:03 freddy77 Exp $";
+static char software_version[] = "$Id: cursor5.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define CHECK_RCODE(t,h,m) \
@@ -56,25 +56,23 @@ int
 main(int argc, char **argv)
 {
 	SQLRETURN rcode;
-	SQLHDBC m_hdbc;
 	SQLHSTMT m_hstmt1;
 	SQLHSTMT m_hstmt2;
 
 	use_odbc_version3 = 1;
 	Connect();
 	CheckCursor();
-	m_hdbc = Connection;
 
-	rcode = SQLSetConnectAttr(m_hdbc, SQL_ATTR_AUTOCOMMIT, (SQLPOINTER) SQL_AUTOCOMMIT_ON, SQL_IS_UINTEGER);
-	CHECK_RCODE(SQL_HANDLE_ENV, m_hdbc, "SQLSetConnectAttr(autocommit)");
+	rcode = SQLSetConnectAttr(Connection, SQL_ATTR_AUTOCOMMIT, (SQLPOINTER) SQL_AUTOCOMMIT_ON, SQL_IS_UINTEGER);
+	CHECK_RCODE(SQL_HANDLE_ENV, Connection, "SQLSetConnectAttr(autocommit)");
 
 	m_hstmt1 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, m_hdbc, &m_hstmt1);
-	CHECK_RCODE(SQL_HANDLE_DBC, m_hdbc, "SQLAllocHandle StmtH 1");
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt1);
+	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle StmtH 1");
 
 	m_hstmt2 = NULL;
-	rcode = SQLAllocHandle(SQL_HANDLE_STMT, m_hdbc, &m_hstmt2);
-	CHECK_RCODE(SQL_HANDLE_DBC, m_hdbc, "SQLAllocHandle StmtH 2");
+	rcode = SQLAllocHandle(SQL_HANDLE_STMT, Connection, &m_hstmt2);
+	CHECK_RCODE(SQL_HANDLE_DBC, Connection, "SQLAllocHandle StmtH 2");
 
 	rcode = SQLExecDirect(m_hstmt1, (SQLCHAR *) "create table #mytab1 (k int, c char(30))", SQL_NTS);
 	CHECK_RCODE(SQL_HANDLE_STMT, m_hstmt1, "SQLExecDirect 1.1");
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 7b60d86..640510e 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -3,7 +3,7 @@
 
 /* Test various bind type */
 
-static char software_version[] = "$Id: data.c,v 1.13 2007/06/21 07:21:21 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.14 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -24,10 +24,7 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, con
 	sprintf(sbuf, "SELECT CONVERT(%s, '%s') AS data", type, value_to_convert);
 	Command(Statement, sbuf);
 	SQLBindCol(Statement, 1, out_c_type, out_buf, sizeof(out_buf), &out_len);
-	if (SQLFetch(Statement) != SQL_SUCCESS) {
-		fprintf(stderr, "Expected row\n");
-		exit(1);
-	}
+	CHK(SQLFetch, (Statement));
 	if (SQLFetch(Statement) != SQL_NO_DATA) {
 		fprintf(stderr, "Row not expected\n");
 		exit(1);
diff --git a/src/odbc/unittests/date.c b/src/odbc/unittests/date.c
index 320e8b1..a37360f 100644
--- a/src/odbc/unittests/date.c
+++ b/src/odbc/unittests/date.c
@@ -1,7 +1,7 @@
 #include "common.h"
 
 
-static char software_version[] = "$Id: date.c,v 1.9 2004/10/28 13:16:18 freddy77 Exp $";
+static char software_version[] = "$Id: date.c,v 1.10 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static void
@@ -18,35 +18,25 @@ DoTest(int n)
 
 	TIMESTAMP_STRUCT ts;
 
-	if (CommandWithResult(Statement, "select convert(datetime, '2002-12-27 18:43:21')") != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to execute statement");
+	Command(Statement, "select convert(datetime, '2002-12-27 18:43:21')");
 
 	res = SQLFetch(Statement);
 	if (res != SQL_SUCCESS && res != SQL_SUCCESS_WITH_INFO)
 		ODBC_REPORT_ERROR("Unable to fetch row");
 
-	if (SQLDescribeCol(Statement, 1, output, sizeof(output), NULL, &colType, &colSize, &colScale, &colNullable) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Error getting data");
+	CHK(SQLDescribeCol, (Statement, 1, output, sizeof(output), NULL, &colType, &colSize, &colScale, &colNullable));
 
 	if (n == 0) {
 		memset(&ts, 0, sizeof(ts));
-		if (SQLGetData(Statement, 1, SQL_C_TIMESTAMP, &ts, sizeof(ts), &dataSize) != SQL_SUCCESS) {
-			printf("Unable to get data col %d\n", 1);
-			CheckReturn();
-			exit(1);
-		}
+		CHK(SQLGetData, (Statement, 1, SQL_C_TIMESTAMP, &ts, sizeof(ts), &dataSize));
 		sprintf((char *) output, "%04d-%02d-%02d %02d:%02d:%02d.000", ts.year, ts.month, ts.day, ts.hour, ts.minute, ts.second);
 	} else {
-		if (SQLGetData(Statement, 1, SQL_C_CHAR, output, sizeof(output), &dataSize) != SQL_SUCCESS) {
-			printf("Unable to get data col %d\n", 1);
-			CheckReturn();
-			exit(1);
-		}
+		CHK(SQLGetData, (Statement, 1, SQL_C_CHAR, output, sizeof(output), &dataSize));
 	}
 
 	printf("Date returned: %s\n", output);
 	if (strcmp((char *) output, "2002-12-27 18:43:21.000") != 0) {
-		printf("Invalid returned date\n");
+		fprintf(stderr, "Invalid returned date\n");
 		exit(1);
 	}
 
diff --git a/src/odbc/unittests/error.c b/src/odbc/unittests/error.c
index 125d002..d8cffb2 100644
--- a/src/odbc/unittests/error.c
+++ b/src/odbc/unittests/error.c
@@ -2,7 +2,7 @@
 
 /* some tests on error reporting */
 
-static char software_version[] = "$Id: error.c,v 1.3 2004/05/22 17:25:27 freddy77 Exp $";
+static char software_version[] = "$Id: error.c,v 1.4 2008/01/29 14:30:48 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static SQLCHAR output[256];
@@ -45,17 +45,15 @@ main(int argc, char *argv[])
 
 		/* TODO when multiple row fetch available test for error on some columns */
 
-		if (SQLFetch(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLFetch failed when it shouldn't");
-		if (SQLFetch(Statement) != SQL_SUCCESS)
-			ODBC_REPORT_ERROR("SQLFetch failed when it shouldn't");
+		CHK(SQLFetch, (Statement));
+		CHK(SQLFetch, (Statement));
 		if (SQLFetch(Statement) != SQL_ERROR)
 			ODBC_REPORT_ERROR("SQLFetch succeed when it shouldn't");
 	}
 
 	ReadError();
 	if (!strstr((char *) output, "zero")) {
-		printf("Message invalid\n");
+		fprintf(stderr, "Message invalid\n");
 		return 1;
 	}
 
@@ -64,8 +62,7 @@ main(int argc, char *argv[])
 	SQLFetch(Statement);
 	SQLMoreResults(Statement);
 
-	if (SQLAllocStmt(Connection, &stmt) != SQL_SUCCESS)
-		ODBC_REPORT_ERROR("Unable to allocate statement");
+	CHK(SQLAllocStmt, (Connection, &stmt));
 
 	Command(Statement, "SELECT * FROM sysobjects");
 
